#include "bits/stdc++.h"

struct Student {
    int s1, s2;
    int zapsany;
    int poradi;

    Student() : zapsany(-1) {}
};

struct School {
    int index;
    std::vector<int> applicants;
    std::vector<int> zapsani;

    School(int C) {
        zapsani.reserve(C);
    }
};

int main() {
    size_t N, M, C;
    std::cin >> N >> M >> C;

    std::vector<Student> students(N);
    std::vector<School> schools(M, C);

    for (size_t i = 0; i < M; ++i) {
        schools[i].index = i;
    }

    for (size_t i = 0; i < N; ++i) {
        int s1, s2;
        std::cin >> s1 >> s2;
        s1--;
        s2--;

        students[i].s1 = s1;
        students[i].s2 = s2;
        students[i].poradi = i;

        schools[s1].applicants.push_back(i);
        schools[s2].applicants.push_back(i);
    }

    while (true) {
        bool valid = false;
        for (School &school: schools) {
            for (ssize_t i = school.applicants.size() - 1; i >= 0; --i) {
                int student_index = school.applicants[i];
                Student &student = students[student_index];
                if (school.zapsani.size() < C) {
                    if (student.zapsany == -1) {
                        school.zapsani.push_back(student_index);
                        student.zapsany = school.index;
                        valid = true;
                        break;
                    } else {
                        if (student.zapsany == student.s2) {
                            int oldschool_index = student.zapsany;
                            School &oldschool = schools[oldschool_index];
                            auto it = std::find(oldschool.zapsani.begin(), oldschool.zapsani.end(), student_index);
//                            std::cout << "v listine je misto, student je zapsany v " << oldschool_index
//                                      << ", ve stare skole jsem nasel " << *it << std::endl;
                            oldschool.zapsani.erase(it);

                            school.zapsani.push_back(student_index);
                            student.zapsany = school.index;
                            valid = true;
                            break;
                        }
                    }
                } else {
                    for (size_t j = 0; j < school.zapsani.size(); ++j) {
                        int &worse_student_index = school.zapsani[j];
                        if (student.poradi < students[worse_student_index].poradi) {
                            students[worse_student_index].zapsany = -1; // odepsat horsiho studenta

                            if (student.zapsany == -1) {
                                school.zapsani[j] = student_index; // zapis lepsiho
                                student.zapsany = school.index;
                                valid = true;
                                goto next_school;
                            } else {
                                if (student.zapsany == student.s2) {
                                    int oldschool_index = student.zapsany;
                                    School &oldschool = schools[oldschool_index];
                                    oldschool.zapsani.erase(
                                            std::find(oldschool.zapsani.begin(), oldschool.zapsani.end(),
                                                      student_index));

                                    school.zapsani[j] = student_index; // zapis lepsiho
                                    student.zapsany = school.index;
                                    valid = true;
                                    goto next_school;
                                }
                            }

                        }
                    }
                }
            }
            next_school:;
        }
        if (!valid) {
            break;
        }
    }

    int primarni = 0;
    int sekundarni = 0;

    for (Student& student: students) {
        if (student.zapsany == student.s1) {
            primarni++;
        } else if (student.zapsany == student.s2) {
            sekundarni++;
        }
    }

    std::cout << primarni << " " << sekundarni << std::endl;

    return 0;
}
