#include "bits/stdc++.h"

int main() {
    int N, M;
    std::cin >> N >> M;

    std::vector<bool> even(N);
    std::vector<int> groups(N);

    int group = 0;
    for (int i = 0; i < N; ++i) {
        int n;
        std::cin >> n;

        even[i] = n % 2 == 0;
        groups[i] = group;

        if (i != N - 1) {
            char op;
            std::cin >> op;


            if (op != '*') {
                ++group;
            }
        }
    }

    std::vector<int> even_in_group(group + 1);
    for (int i = 0; i < N; ++i) {
        if (even[i]) {
            even_in_group[groups[i]]++;
        }
    }

    int zeros = 0;
    for (int i = 0; i < group + 1; ++i) {
        if (even_in_group[i] == 0) {
            zeros++;
        }
    }

    if (zeros % 2 == 0) {
        std::cout << "even" << std::endl;
    } else {
        std::cout << "odd" << std::endl;
    }


    for (int i = 0; i < M; ++i) {
        int index, new_num;
        std::cin >> index >> new_num;

        index--;

        if (even[index] != (new_num % 2 == 0)) {
            if (even[index]) {
                even_in_group[groups[index]]--;
                if (even_in_group[groups[index]] == 0) {
                    zeros++;
                }
            } else {
                even_in_group[groups[index]]++;
                if (even_in_group[groups[index]] == 1) {
                    zeros--;
                }
            }
        }

        even[index] = (new_num % 2 == 0);

        if (zeros % 2 == 0) {
            std::cout << "even" << std::endl;
        } else {
            std::cout << "odd" << std::endl;
        }
    }

//    std::cout << "even in group: ";
//    for (int i = 0; i < group + 1; ++i) {
//        std::cout << even_in_group[i];
//    }
//    std::cout << std::endl;

//    std::cout << "evenodd: ";
//    for (int i = 0; i < N; ++i) {
//        std::cout << even[i];
//    }
//    std::cout << std::endl;
//
//    std::cout << "groups: ";
//    for (int i = 0; i < N; ++i) {
//        std::cout << groups[i];
//    }
//    std::cout << std::endl;

    return 0;
}
